//
// FacesAPI.swift
//
// Generated by swagger-codegen
// https://github.com/swagger-api/swagger-codegen
//

import Foundation
import Alamofire


open class FacesAPI {
    /**
     Add provided images to the face with provided ID

     - parameter body: (body)  
     - parameter faceId: (path)  
     - parameter completion: completion handler to receive the data and the error objects
     */
    open class func addFaceImages(body: FaceImagesBody, faceId: Int, completion: @escaping ((_ data: FaceImageList?,_ error: Error?) -> Void)) {
        addFaceImagesWithRequestBuilder(body: body, faceId: faceId).execute { (response, error) -> Void in
            completion(response?.body, error)
        }
    }


    /**
     Add provided images to the face with provided ID
     - POST /api/v1/faces/{face_id}/images

     - OAuth:
       - type: oauth2
       - name: OAuth2PasswordBearer
     - examples: [{contentType=application/json, example={
  "faceimages" : [ {
    "mime_type" : "mime_type",
    "kind" : "avatar",
    "meta" : {
      "detection" : {
        "rect" : {
          "y_min" : 1.4658129805029452,
          "x_max" : 5.962133916683182,
          "y_max" : 5.637376656633329,
          "x_min" : 6.027456183070403
        },
        "landmarks" : [ {
          "x" : 2.3021358869347655,
          "y" : 7.061401241503109
        }, {
          "x" : 2.3021358869347655,
          "y" : 7.061401241503109
        } ]
      },
      "descriptor" : {
        "data" : "data",
        "norm" : 9.301444243932576
      }
    },
    "created_at" : "2000-01-23T04:56:07.000+00:00",
    "id" : "046b6c7f-0b8a-43b9-b35d-6489e6daee91",
    "original_id" : "046b6c7f-0b8a-43b9-b35d-6489e6daee91",
    "url" : "http://example.com/aeiou"
  }, {
    "mime_type" : "mime_type",
    "kind" : "avatar",
    "meta" : {
      "detection" : {
        "rect" : {
          "y_min" : 1.4658129805029452,
          "x_max" : 5.962133916683182,
          "y_max" : 5.637376656633329,
          "x_min" : 6.027456183070403
        },
        "landmarks" : [ {
          "x" : 2.3021358869347655,
          "y" : 7.061401241503109
        }, {
          "x" : 2.3021358869347655,
          "y" : 7.061401241503109
        } ]
      },
      "descriptor" : {
        "data" : "data",
        "norm" : 9.301444243932576
      }
    },
    "created_at" : "2000-01-23T04:56:07.000+00:00",
    "id" : "046b6c7f-0b8a-43b9-b35d-6489e6daee91",
    "original_id" : "046b6c7f-0b8a-43b9-b35d-6489e6daee91",
    "url" : "http://example.com/aeiou"
  } ]
}}]
     - parameter body: (body)  
     - parameter faceId: (path)  

     - returns: RequestBuilder<FaceImageList> 
     */
    open class func addFaceImagesWithRequestBuilder(body: FaceImagesBody, faceId: Int) -> RequestBuilder<FaceImageList> {
        var path = "/api/v1/faces/{face_id}/images"
        let faceIdPreEscape = "\(faceId)"
        let faceIdPostEscape = faceIdPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        path = path.replacingOccurrences(of: "{face_id}", with: faceIdPostEscape, options: .literal, range: nil)
        let URLString = SwaggerClientAPI.basePath + path
        let parameters = JSONEncodingHelper.encodingParameters(forEncodableObject: body)
        let url = URLComponents(string: URLString)


        let requestBuilder: RequestBuilder<FaceImageList>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "POST", URLString: (url?.string ?? URLString), parameters: parameters, isBody: true)
    }
    /**
     Create new face

     - parameter body: (body)  
     - parameter completion: completion handler to receive the data and the error objects
     */
    open class func createFace(body: FaceCreate, completion: @escaping ((_ data: FaceGet?,_ error: Error?) -> Void)) {
        createFaceWithRequestBuilder(body: body).execute { (response, error) -> Void in
            completion(response?.body, error)
        }
    }


    /**
     Create new face
     - POST /api/v1/faces

     - OAuth:
       - type: oauth2
       - name: OAuth2PasswordBearer
     - examples: [{contentType=application/json, example={
  "images" : [ {
    "mime_type" : "mime_type",
    "kind" : "avatar",
    "meta" : {
      "detection" : {
        "rect" : {
          "y_min" : 1.4658129805029452,
          "x_max" : 5.962133916683182,
          "y_max" : 5.637376656633329,
          "x_min" : 6.027456183070403
        },
        "landmarks" : [ {
          "x" : 2.3021358869347655,
          "y" : 7.061401241503109
        }, {
          "x" : 2.3021358869347655,
          "y" : 7.061401241503109
        } ]
      },
      "descriptor" : {
        "data" : "data",
        "norm" : 9.301444243932576
      }
    },
    "created_at" : "2000-01-23T04:56:07.000+00:00",
    "id" : "046b6c7f-0b8a-43b9-b35d-6489e6daee91",
    "original_id" : "046b6c7f-0b8a-43b9-b35d-6489e6daee91",
    "url" : "http://example.com/aeiou"
  }, {
    "mime_type" : "mime_type",
    "kind" : "avatar",
    "meta" : {
      "detection" : {
        "rect" : {
          "y_min" : 1.4658129805029452,
          "x_max" : 5.962133916683182,
          "y_max" : 5.637376656633329,
          "x_min" : 6.027456183070403
        },
        "landmarks" : [ {
          "x" : 2.3021358869347655,
          "y" : 7.061401241503109
        }, {
          "x" : 2.3021358869347655,
          "y" : 7.061401241503109
        } ]
      },
      "descriptor" : {
        "data" : "data",
        "norm" : 9.301444243932576
      }
    },
    "created_at" : "2000-01-23T04:56:07.000+00:00",
    "id" : "046b6c7f-0b8a-43b9-b35d-6489e6daee91",
    "original_id" : "046b6c7f-0b8a-43b9-b35d-6489e6daee91",
    "url" : "http://example.com/aeiou"
  } ],
  "full_name" : "full_name",
  "document_number" : "document_number",
  "sex" : "m",
  "birth_date" : "2000-01-23",
  "id" : 0
}}]
     - parameter body: (body)  

     - returns: RequestBuilder<FaceGet> 
     */
    open class func createFaceWithRequestBuilder(body: FaceCreate) -> RequestBuilder<FaceGet> {
        let path = "/api/v1/faces"
        let URLString = SwaggerClientAPI.basePath + path
        let parameters = JSONEncodingHelper.encodingParameters(forEncodableObject: body)
        let url = URLComponents(string: URLString)


        let requestBuilder: RequestBuilder<FaceGet>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "POST", URLString: (url?.string ?? URLString), parameters: parameters, isBody: true)
    }
    /**
     Delete face with provided ID

     - parameter faceId: (path)  
     - parameter completion: completion handler to receive the data and the error objects
     */
    open class func deleteFace(faceId: Int, completion: @escaping ((_ data: APIResponseStatusOK?,_ error: Error?) -> Void)) {
        deleteFaceWithRequestBuilder(faceId: faceId).execute { (response, error) -> Void in
            completion(response?.body, error)
        }
    }


    /**
     Delete face with provided ID
     - DELETE /api/v1/faces/{face_id}

     - OAuth:
       - type: oauth2
       - name: OAuth2PasswordBearer
     - examples: [{contentType=application/json, example={
  "status" : "ok"
}}]
     - parameter faceId: (path)  

     - returns: RequestBuilder<APIResponseStatusOK> 
     */
    open class func deleteFaceWithRequestBuilder(faceId: Int) -> RequestBuilder<APIResponseStatusOK> {
        var path = "/api/v1/faces/{face_id}"
        let faceIdPreEscape = "\(faceId)"
        let faceIdPostEscape = faceIdPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        path = path.replacingOccurrences(of: "{face_id}", with: faceIdPostEscape, options: .literal, range: nil)
        let URLString = SwaggerClientAPI.basePath + path
        let parameters: [String:Any]? = nil
        let url = URLComponents(string: URLString)


        let requestBuilder: RequestBuilder<APIResponseStatusOK>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "DELETE", URLString: (url?.string ?? URLString), parameters: parameters, isBody: false)
    }
    /**
     Get face with provided ID

     - parameter faceId: (path)  
     - parameter completion: completion handler to receive the data and the error objects
     */
    open class func getFace(faceId: Int, completion: @escaping ((_ data: FaceGet?,_ error: Error?) -> Void)) {
        getFaceWithRequestBuilder(faceId: faceId).execute { (response, error) -> Void in
            completion(response?.body, error)
        }
    }


    /**
     Get face with provided ID
     - GET /api/v1/faces/{face_id}

     - OAuth:
       - type: oauth2
       - name: OAuth2PasswordBearer
     - examples: [{contentType=application/json, example={
  "images" : [ {
    "mime_type" : "mime_type",
    "kind" : "avatar",
    "meta" : {
      "detection" : {
        "rect" : {
          "y_min" : 1.4658129805029452,
          "x_max" : 5.962133916683182,
          "y_max" : 5.637376656633329,
          "x_min" : 6.027456183070403
        },
        "landmarks" : [ {
          "x" : 2.3021358869347655,
          "y" : 7.061401241503109
        }, {
          "x" : 2.3021358869347655,
          "y" : 7.061401241503109
        } ]
      },
      "descriptor" : {
        "data" : "data",
        "norm" : 9.301444243932576
      }
    },
    "created_at" : "2000-01-23T04:56:07.000+00:00",
    "id" : "046b6c7f-0b8a-43b9-b35d-6489e6daee91",
    "original_id" : "046b6c7f-0b8a-43b9-b35d-6489e6daee91",
    "url" : "http://example.com/aeiou"
  }, {
    "mime_type" : "mime_type",
    "kind" : "avatar",
    "meta" : {
      "detection" : {
        "rect" : {
          "y_min" : 1.4658129805029452,
          "x_max" : 5.962133916683182,
          "y_max" : 5.637376656633329,
          "x_min" : 6.027456183070403
        },
        "landmarks" : [ {
          "x" : 2.3021358869347655,
          "y" : 7.061401241503109
        }, {
          "x" : 2.3021358869347655,
          "y" : 7.061401241503109
        } ]
      },
      "descriptor" : {
        "data" : "data",
        "norm" : 9.301444243932576
      }
    },
    "created_at" : "2000-01-23T04:56:07.000+00:00",
    "id" : "046b6c7f-0b8a-43b9-b35d-6489e6daee91",
    "original_id" : "046b6c7f-0b8a-43b9-b35d-6489e6daee91",
    "url" : "http://example.com/aeiou"
  } ],
  "full_name" : "full_name",
  "document_number" : "document_number",
  "sex" : "m",
  "birth_date" : "2000-01-23",
  "id" : 0
}}]
     - parameter faceId: (path)  

     - returns: RequestBuilder<FaceGet> 
     */
    open class func getFaceWithRequestBuilder(faceId: Int) -> RequestBuilder<FaceGet> {
        var path = "/api/v1/faces/{face_id}"
        let faceIdPreEscape = "\(faceId)"
        let faceIdPostEscape = faceIdPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        path = path.replacingOccurrences(of: "{face_id}", with: faceIdPostEscape, options: .literal, range: nil)
        let URLString = SwaggerClientAPI.basePath + path
        let parameters: [String:Any]? = nil
        let url = URLComponents(string: URLString)


        let requestBuilder: RequestBuilder<FaceGet>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "GET", URLString: (url?.string ?? URLString), parameters: parameters, isBody: false)
    }
    /**
     Get the list of images attached to a face with provided ID

     - parameter faceId: (path)  
     - parameter completion: completion handler to receive the data and the error objects
     */
    open class func getFaceImages(faceId: Int, completion: @escaping ((_ data: FaceImageList?,_ error: Error?) -> Void)) {
        getFaceImagesWithRequestBuilder(faceId: faceId).execute { (response, error) -> Void in
            completion(response?.body, error)
        }
    }


    /**
     Get the list of images attached to a face with provided ID
     - GET /api/v1/faces/{face_id}/images

     - OAuth:
       - type: oauth2
       - name: OAuth2PasswordBearer
     - examples: [{contentType=application/json, example={
  "faceimages" : [ {
    "mime_type" : "mime_type",
    "kind" : "avatar",
    "meta" : {
      "detection" : {
        "rect" : {
          "y_min" : 1.4658129805029452,
          "x_max" : 5.962133916683182,
          "y_max" : 5.637376656633329,
          "x_min" : 6.027456183070403
        },
        "landmarks" : [ {
          "x" : 2.3021358869347655,
          "y" : 7.061401241503109
        }, {
          "x" : 2.3021358869347655,
          "y" : 7.061401241503109
        } ]
      },
      "descriptor" : {
        "data" : "data",
        "norm" : 9.301444243932576
      }
    },
    "created_at" : "2000-01-23T04:56:07.000+00:00",
    "id" : "046b6c7f-0b8a-43b9-b35d-6489e6daee91",
    "original_id" : "046b6c7f-0b8a-43b9-b35d-6489e6daee91",
    "url" : "http://example.com/aeiou"
  }, {
    "mime_type" : "mime_type",
    "kind" : "avatar",
    "meta" : {
      "detection" : {
        "rect" : {
          "y_min" : 1.4658129805029452,
          "x_max" : 5.962133916683182,
          "y_max" : 5.637376656633329,
          "x_min" : 6.027456183070403
        },
        "landmarks" : [ {
          "x" : 2.3021358869347655,
          "y" : 7.061401241503109
        }, {
          "x" : 2.3021358869347655,
          "y" : 7.061401241503109
        } ]
      },
      "descriptor" : {
        "data" : "data",
        "norm" : 9.301444243932576
      }
    },
    "created_at" : "2000-01-23T04:56:07.000+00:00",
    "id" : "046b6c7f-0b8a-43b9-b35d-6489e6daee91",
    "original_id" : "046b6c7f-0b8a-43b9-b35d-6489e6daee91",
    "url" : "http://example.com/aeiou"
  } ]
}}]
     - parameter faceId: (path)  

     - returns: RequestBuilder<FaceImageList> 
     */
    open class func getFaceImagesWithRequestBuilder(faceId: Int) -> RequestBuilder<FaceImageList> {
        var path = "/api/v1/faces/{face_id}/images"
        let faceIdPreEscape = "\(faceId)"
        let faceIdPostEscape = faceIdPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        path = path.replacingOccurrences(of: "{face_id}", with: faceIdPostEscape, options: .literal, range: nil)
        let URLString = SwaggerClientAPI.basePath + path
        let parameters: [String:Any]? = nil
        let url = URLComponents(string: URLString)


        let requestBuilder: RequestBuilder<FaceImageList>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "GET", URLString: (url?.string ?? URLString), parameters: parameters, isBody: false)
    }
    /**
     Get all faces optionally filtered by full name

     - parameter fullName: (query)  (optional)
     - parameter completion: completion handler to receive the data and the error objects
     */
    open class func getFaces(fullName: String? = nil, completion: @escaping ((_ data: FaceGetList?,_ error: Error?) -> Void)) {
        getFacesWithRequestBuilder(fullName: fullName).execute { (response, error) -> Void in
            completion(response?.body, error)
        }
    }


    /**
     Get all faces optionally filtered by full name
     - GET /api/v1/faces

     - OAuth:
       - type: oauth2
       - name: OAuth2PasswordBearer
     - examples: [{contentType=application/json, example={
  "faces" : [ {
    "images" : [ {
      "mime_type" : "mime_type",
      "kind" : "avatar",
      "meta" : {
        "detection" : {
          "rect" : {
            "y_min" : 1.4658129805029452,
            "x_max" : 5.962133916683182,
            "y_max" : 5.637376656633329,
            "x_min" : 6.027456183070403
          },
          "landmarks" : [ {
            "x" : 2.3021358869347655,
            "y" : 7.061401241503109
          }, {
            "x" : 2.3021358869347655,
            "y" : 7.061401241503109
          } ]
        },
        "descriptor" : {
          "data" : "data",
          "norm" : 9.301444243932576
        }
      },
      "created_at" : "2000-01-23T04:56:07.000+00:00",
      "id" : "046b6c7f-0b8a-43b9-b35d-6489e6daee91",
      "original_id" : "046b6c7f-0b8a-43b9-b35d-6489e6daee91",
      "url" : "http://example.com/aeiou"
    }, {
      "mime_type" : "mime_type",
      "kind" : "avatar",
      "meta" : {
        "detection" : {
          "rect" : {
            "y_min" : 1.4658129805029452,
            "x_max" : 5.962133916683182,
            "y_max" : 5.637376656633329,
            "x_min" : 6.027456183070403
          },
          "landmarks" : [ {
            "x" : 2.3021358869347655,
            "y" : 7.061401241503109
          }, {
            "x" : 2.3021358869347655,
            "y" : 7.061401241503109
          } ]
        },
        "descriptor" : {
          "data" : "data",
          "norm" : 9.301444243932576
        }
      },
      "created_at" : "2000-01-23T04:56:07.000+00:00",
      "id" : "046b6c7f-0b8a-43b9-b35d-6489e6daee91",
      "original_id" : "046b6c7f-0b8a-43b9-b35d-6489e6daee91",
      "url" : "http://example.com/aeiou"
    } ],
    "full_name" : "full_name",
    "document_number" : "document_number",
    "sex" : "m",
    "birth_date" : "2000-01-23",
    "id" : 0
  }, {
    "images" : [ {
      "mime_type" : "mime_type",
      "kind" : "avatar",
      "meta" : {
        "detection" : {
          "rect" : {
            "y_min" : 1.4658129805029452,
            "x_max" : 5.962133916683182,
            "y_max" : 5.637376656633329,
            "x_min" : 6.027456183070403
          },
          "landmarks" : [ {
            "x" : 2.3021358869347655,
            "y" : 7.061401241503109
          }, {
            "x" : 2.3021358869347655,
            "y" : 7.061401241503109
          } ]
        },
        "descriptor" : {
          "data" : "data",
          "norm" : 9.301444243932576
        }
      },
      "created_at" : "2000-01-23T04:56:07.000+00:00",
      "id" : "046b6c7f-0b8a-43b9-b35d-6489e6daee91",
      "original_id" : "046b6c7f-0b8a-43b9-b35d-6489e6daee91",
      "url" : "http://example.com/aeiou"
    }, {
      "mime_type" : "mime_type",
      "kind" : "avatar",
      "meta" : {
        "detection" : {
          "rect" : {
            "y_min" : 1.4658129805029452,
            "x_max" : 5.962133916683182,
            "y_max" : 5.637376656633329,
            "x_min" : 6.027456183070403
          },
          "landmarks" : [ {
            "x" : 2.3021358869347655,
            "y" : 7.061401241503109
          }, {
            "x" : 2.3021358869347655,
            "y" : 7.061401241503109
          } ]
        },
        "descriptor" : {
          "data" : "data",
          "norm" : 9.301444243932576
        }
      },
      "created_at" : "2000-01-23T04:56:07.000+00:00",
      "id" : "046b6c7f-0b8a-43b9-b35d-6489e6daee91",
      "original_id" : "046b6c7f-0b8a-43b9-b35d-6489e6daee91",
      "url" : "http://example.com/aeiou"
    } ],
    "full_name" : "full_name",
    "document_number" : "document_number",
    "sex" : "m",
    "birth_date" : "2000-01-23",
    "id" : 0
  } ]
}}]
     - parameter fullName: (query)  (optional)

     - returns: RequestBuilder<FaceGetList> 
     */
    open class func getFacesWithRequestBuilder(fullName: String? = nil) -> RequestBuilder<FaceGetList> {
        let path = "/api/v1/faces"
        let URLString = SwaggerClientAPI.basePath + path
        let parameters: [String:Any]? = nil
        var url = URLComponents(string: URLString)
        url?.queryItems = APIHelper.mapValuesToQueryItems([
                        "full_name": fullName
        ])


        let requestBuilder: RequestBuilder<FaceGetList>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "GET", URLString: (url?.string ?? URLString), parameters: parameters, isBody: false)
    }
    /**
     Detach provided images from the face with provided ID

     - parameter body: (body)  
     - parameter faceId: (path)  
     - parameter completion: completion handler to receive the data and the error objects
     */
    open class func removeFaceImages(body: FaceImagesBody, faceId: Int, completion: @escaping ((_ data: FaceImageList?,_ error: Error?) -> Void)) {
        removeFaceImagesWithRequestBuilder(body: body, faceId: faceId).execute { (response, error) -> Void in
            completion(response?.body, error)
        }
    }


    /**
     Detach provided images from the face with provided ID
     - DELETE /api/v1/faces/{face_id}/images

     - OAuth:
       - type: oauth2
       - name: OAuth2PasswordBearer
     - examples: [{contentType=application/json, example={
  "faceimages" : [ {
    "mime_type" : "mime_type",
    "kind" : "avatar",
    "meta" : {
      "detection" : {
        "rect" : {
          "y_min" : 1.4658129805029452,
          "x_max" : 5.962133916683182,
          "y_max" : 5.637376656633329,
          "x_min" : 6.027456183070403
        },
        "landmarks" : [ {
          "x" : 2.3021358869347655,
          "y" : 7.061401241503109
        }, {
          "x" : 2.3021358869347655,
          "y" : 7.061401241503109
        } ]
      },
      "descriptor" : {
        "data" : "data",
        "norm" : 9.301444243932576
      }
    },
    "created_at" : "2000-01-23T04:56:07.000+00:00",
    "id" : "046b6c7f-0b8a-43b9-b35d-6489e6daee91",
    "original_id" : "046b6c7f-0b8a-43b9-b35d-6489e6daee91",
    "url" : "http://example.com/aeiou"
  }, {
    "mime_type" : "mime_type",
    "kind" : "avatar",
    "meta" : {
      "detection" : {
        "rect" : {
          "y_min" : 1.4658129805029452,
          "x_max" : 5.962133916683182,
          "y_max" : 5.637376656633329,
          "x_min" : 6.027456183070403
        },
        "landmarks" : [ {
          "x" : 2.3021358869347655,
          "y" : 7.061401241503109
        }, {
          "x" : 2.3021358869347655,
          "y" : 7.061401241503109
        } ]
      },
      "descriptor" : {
        "data" : "data",
        "norm" : 9.301444243932576
      }
    },
    "created_at" : "2000-01-23T04:56:07.000+00:00",
    "id" : "046b6c7f-0b8a-43b9-b35d-6489e6daee91",
    "original_id" : "046b6c7f-0b8a-43b9-b35d-6489e6daee91",
    "url" : "http://example.com/aeiou"
  } ]
}}]
     - parameter body: (body)  
     - parameter faceId: (path)  

     - returns: RequestBuilder<FaceImageList> 
     */
    open class func removeFaceImagesWithRequestBuilder(body: FaceImagesBody, faceId: Int) -> RequestBuilder<FaceImageList> {
        var path = "/api/v1/faces/{face_id}/images"
        let faceIdPreEscape = "\(faceId)"
        let faceIdPostEscape = faceIdPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        path = path.replacingOccurrences(of: "{face_id}", with: faceIdPostEscape, options: .literal, range: nil)
        let URLString = SwaggerClientAPI.basePath + path
        let parameters = JSONEncodingHelper.encodingParameters(forEncodableObject: body)
        let url = URLComponents(string: URLString)


        let requestBuilder: RequestBuilder<FaceImageList>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "DELETE", URLString: (url?.string ?? URLString), parameters: parameters, isBody: true)
    }
    /**
     Update face with provided ID

     - parameter body: (body)  
     - parameter faceId: (path)  
     - parameter completion: completion handler to receive the data and the error objects
     */
    open class func updateFace(body: FaceUpdate, faceId: Int, completion: @escaping ((_ data: FaceGet?,_ error: Error?) -> Void)) {
        updateFaceWithRequestBuilder(body: body, faceId: faceId).execute { (response, error) -> Void in
            completion(response?.body, error)
        }
    }


    /**
     Update face with provided ID
     - PUT /api/v1/faces/{face_id}

     - OAuth:
       - type: oauth2
       - name: OAuth2PasswordBearer
     - examples: [{contentType=application/json, example={
  "images" : [ {
    "mime_type" : "mime_type",
    "kind" : "avatar",
    "meta" : {
      "detection" : {
        "rect" : {
          "y_min" : 1.4658129805029452,
          "x_max" : 5.962133916683182,
          "y_max" : 5.637376656633329,
          "x_min" : 6.027456183070403
        },
        "landmarks" : [ {
          "x" : 2.3021358869347655,
          "y" : 7.061401241503109
        }, {
          "x" : 2.3021358869347655,
          "y" : 7.061401241503109
        } ]
      },
      "descriptor" : {
        "data" : "data",
        "norm" : 9.301444243932576
      }
    },
    "created_at" : "2000-01-23T04:56:07.000+00:00",
    "id" : "046b6c7f-0b8a-43b9-b35d-6489e6daee91",
    "original_id" : "046b6c7f-0b8a-43b9-b35d-6489e6daee91",
    "url" : "http://example.com/aeiou"
  }, {
    "mime_type" : "mime_type",
    "kind" : "avatar",
    "meta" : {
      "detection" : {
        "rect" : {
          "y_min" : 1.4658129805029452,
          "x_max" : 5.962133916683182,
          "y_max" : 5.637376656633329,
          "x_min" : 6.027456183070403
        },
        "landmarks" : [ {
          "x" : 2.3021358869347655,
          "y" : 7.061401241503109
        }, {
          "x" : 2.3021358869347655,
          "y" : 7.061401241503109
        } ]
      },
      "descriptor" : {
        "data" : "data",
        "norm" : 9.301444243932576
      }
    },
    "created_at" : "2000-01-23T04:56:07.000+00:00",
    "id" : "046b6c7f-0b8a-43b9-b35d-6489e6daee91",
    "original_id" : "046b6c7f-0b8a-43b9-b35d-6489e6daee91",
    "url" : "http://example.com/aeiou"
  } ],
  "full_name" : "full_name",
  "document_number" : "document_number",
  "sex" : "m",
  "birth_date" : "2000-01-23",
  "id" : 0
}}]
     - parameter body: (body)  
     - parameter faceId: (path)  

     - returns: RequestBuilder<FaceGet> 
     */
    open class func updateFaceWithRequestBuilder(body: FaceUpdate, faceId: Int) -> RequestBuilder<FaceGet> {
        var path = "/api/v1/faces/{face_id}"
        let faceIdPreEscape = "\(faceId)"
        let faceIdPostEscape = faceIdPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        path = path.replacingOccurrences(of: "{face_id}", with: faceIdPostEscape, options: .literal, range: nil)
        let URLString = SwaggerClientAPI.basePath + path
        let parameters = JSONEncodingHelper.encodingParameters(forEncodableObject: body)
        let url = URLComponents(string: URLString)


        let requestBuilder: RequestBuilder<FaceGet>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "PUT", URLString: (url?.string ?? URLString), parameters: parameters, isBody: true)
    }
}
